(function($) {

  var 

    $bus = $,

    defaults = {
      bridgeObject: window.$JsBridge
    };

    function JsBridge(options) {
      this.settings = options;
      if (this.settings.bridgeObject !== null || this.settings.bridgeObject !== undefined) {
        this.bridgeObject = this.settings.bridgeObject
      } else {
        throw new Error("$JsBridge must exist.");
      }
      this.init();
    };

    JsBridge.prototype = {
      init: function() { },

      on: function(ev, f) {
        $('body').on(ev, f);
        return this;
      },

      openCamera: function(callback) {
        if (callback !== null & callback !== undefined) {
          this.on("jsbridge.camera.picture_taken", callback);
        }
        this.sendMessage({ ev: "jsbridge.camera.take_picture", args: []});
      },

      openFileChooser: function(callback) {
        if (callback !== null & callback !== undefined) {
          this.on("jsbridge.filechooser.picture_chosen", callback);
        }
        this.sendMessage({ ev: "jsbridge.filechooser.choose_picture", args: []});
      },

      sendMessage: function(msg) {
        var j = JSON.stringify(msg);
        this.bridgeObject.receiveMessage(j);
        return this;
      },

      receiveMessage: function(msg) {
        //$bus.trigger(j.ev, [btoa(j.args[0])]);
      },
      receiveMessageSimple: function(ev, data) {
        $('body').trigger(ev, [data]);
      }
    };

    var JsBridgeFactory = {
      create: function(options) {
        return new JsBridge($.extend({}, options, defaults));
      }
    };


  var tmp = JsBridgeFactory.create({});
  window.JsBridge = tmp;

  return tmp;

})(jQuery);

